Index: LMDZ.3.3/branches/rel-1-0-patch/create_make_gcm
===================================================================
--- LMDZ.3.3/branches/LF/create_make_gcm	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/create_make_gcm	(revision 253)
@@ -10,4 +10,12 @@
   CRAY=1
 fi
+XNEC=0
+if [ "$machine" = "rhodes" ] ; then
+  XNEC=1
+fi
+VPP=0
+if [ "$machine" = "nymphea0" ] ; then
+  VPP=1
+fi
 #
 echo "#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
@@ -43,12 +51,23 @@
 echo '# Les differentes librairies pour l"edition des liens:'
 echo
-echo 'dyn3d      = $(LIBO)/libdyn3d.a $(LIBO)/lib$(FILTRE).a'
-echo 'dyn2d      = $(LIBO)/libdyn2d.a'
-echo 'dyn1d      = $(LIBO)/libdyn1d.a'
-echo 'L_DYN      = -ldyn$(DIM)d'
-echo 'L_FILTRE   = -l$(FILTRE)'
-echo 'L_PHY = -lphy$(PHYS) '
-echo 'L_BIBIO    = -lbibio'
-echo 'L_ADJNT    ='
+if [ "$XNEC" = '1' ] ; then
+  echo 'dyn3d      = $(LIBO)/libsxdyn3d.a $(LIBO)/libsx$(FILTRE).a'
+  echo 'dyn2d      = $(LIBO)/libsxdyn2d.a'
+  echo 'dyn1d      = $(LIBO)/libsxdyn1d.a'
+  echo 'L_DYN      = -lsxdyn$(DIM)d'
+  echo 'L_FILTRE   = -lsx$(FILTRE)'
+  echo 'L_PHY = -lsxphy$(PHYS) '
+  echo 'L_BIBIO    = -lsxbibio'
+  echo 'L_ADJNT    ='
+else
+  echo 'dyn3d      = $(LIBO)/libdyn3d.a $(LIBO)/lib$(FILTRE).a'
+  echo 'dyn2d      = $(LIBO)/libdyn2d.a'
+  echo 'dyn1d      = $(LIBO)/libdyn1d.a'
+  echo 'L_DYN      = -ldyn$(DIM)d'
+  echo 'L_FILTRE   = -l$(FILTRE)'
+  echo 'L_PHY = -lphy$(PHYS) '
+  echo 'L_BIBIO    = -lbibio'
+  echo 'L_ADJNT    ='
+fi
 echo
 echo "#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
@@ -58,6 +77,7 @@
    echo 'COMPILE = $(F77) $(OPTIM) $(INCLUDE) -c'
    echo 'COMPILE90 = $(F90) $(OPTIM90) $(INCLUDE) -c'
-   echo 'LINK    = f90'
-   echo "AR      = ar"
+   echo 'COMPTRU90 = $(F90) $(OPTIMTRU90) $(INCLUDE) -c'
+   echo "LINK    = $LINK"
+   echo "AR      = $AR"
 echo
 echo
@@ -73,10 +93,9 @@
 echo 'main : $(DYN) bibio phys $(OPTION_DEP) '
 echo '	cd $(LIBO) ; $(RANLIB) lib*.a ; cd $(GCM) ;\'
-if [ "$CRAY" = '0' ] ; then
 echo '	cd $(LOCAL_DIR); \'
-#echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
-echo '	$(COMPILE) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
-else
-echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(PROG).F ; \'
+if [ "$CRAY" = '1' -o "$VPP" = '1' ] ; then
+  echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
+else
+  echo '	$(COMPILE) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
 fi
 if [ "$CRAY" = '0' ] ; then
@@ -109,5 +128,5 @@
 do
    if [ -d $diri ] ; then
-   if [ "`ls $diri/*.F`" != "" ] ; then 
+   if [ "`ls $diri/*.F`" != "" ] || [ "`ls $diri/*.F90`" != "" ]  ; then 
       cd $diri >/dev/null 2>&1
       echo
@@ -121,4 +140,12 @@
          fi
       done
+      for i in `ls *.F90`
+      do
+         fili=`basename $i .F90`
+         test=` (  head $i | grep '      PROGRAM' ) `
+         if [ "$test" = "" ] ; then
+            listlib=$listlib" "$fili
+         fi 
+      done
 #
       echo
@@ -140,15 +167,21 @@
       for fili in $listlib
       do
-         F90=0 ; egrep -i '^ *use ' $fili.F > /dev/null 2>&1 && F90=1
-                 egrep -i '^ *module ' $fili.F > /dev/null 2>&1 && F90=1
-         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$diri/$fili.F
+         if [ -f $fili.F90 ] ; then
+           trufile=$fili.F90
+         else
+           trufile=$fili.F
+         fi
+         F90=0 ; egrep -i '^ *use ' $trufile > /dev/null 2>&1 && F90=1
+                 egrep -i '^ *module ' $trufile > /dev/null 2>&1 && F90=1
+         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$diri/$trufile
          [ "$fili" = "chem.subs" ] && str1=$str1' $(LIBF)/'$diri/chem.mods.F
-         for stri in ` ( sed -n "/\#include/s/\#include//p" $fili.F | sed 's/\"//g' ; egrep -i '^ *use ' $fili.F | awk ' { print $2 } ' ) `
+         for stri in ` ( sed -n "/\#include/s/\#include//p" $trufile | sed 's/\"//g' ; egrep -i '^ *use ' $trufile | awk ' { print $2 } ' ) `
          do
+            stri=`echo $stri | tr [A-Z] [a-z]`
             if [ -f $stri ] ; then
                echo $str1 \\
                str1='$(LIBF)/'$diri'/'$stri
             else
-               if [ -f $stri.F ] ; then
+               if [ -f $stri.F ] || [ -f $stri.F90 ] ; then
                   str1='$(LIBO)/lib'$diri'.a('$stri'.o)'
                else
@@ -165,10 +198,14 @@
          echo $str1
 	 if [ "$F90" -eq '0' ] ; then
-            echo '	cd $(LOCAL_DIR); \'
-	    echo '	$(COMPILE) $(LIBF)/'$diri'/'$fili'.F ; \'
+           echo '	cd $(LOCAL_DIR); \'
+	   echo '	$(COMPILE) $(LIBF)/'$diri'/'$trufile' ; \'
 	 else
-            echo '	cd $(LOCAL_DIR); \'
-	    echo '	$(COMPILE90) $(LIBF)/'$diri'/'$fili'.F ; \'
-            MODU=0; egrep -i ' *module ' $fili.F> /dev/null 2>&1 && MODU=1
+           echo '	cd $(LOCAL_DIR); \'
+           if [ -f $fili.F90 ] ; then
+	      echo '	$(COMPTRU90) $(LIBF)/'$diri'/'$trufile' ; \'
+           else
+	      echo '	$(COMPILE90) $(LIBF)/'$diri'/'$trufile' ; \'
+           fi
+           MODU=0; egrep -i ' *module ' $trufile> /dev/null 2>&1 && MODU=1
             if [ "$MODU" -eq '1' -a "$CRAY" != '1' ] ; then
               if [ "$os" = 'UNIX_System_V' ] ; then
@@ -179,4 +216,7 @@
             fi
 	 fi
+         if [ "$XNEC" -eq '1' ] ; then
+           echo '	sxar r $(LIBO)/libsx'$diri'.a '$fili'.o ; \'
+         fi
          echo '	$(AR) r $(LIBO)/lib'$diri'.a '$fili'.o ; $(RM) '$fili'.o ; \'
          echo '	cd $(GCM)'
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/formcoord.F
===================================================================
--- LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/formcoord.F	(revision 253)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/formcoord.F	(revision 253)
@@ -0,0 +1,51 @@
+      subroutine formcoord(unit,n,x,a,rev,text)
+      implicit none
+      integer n,unit,ndec
+      logical rev
+      real x(n),a
+      character*4 text
+
+      integer i,id,i1,i2,in
+      real dx,dxmin
+
+      if(rev) then
+         id=-1
+         i1=n
+         i2=n-1
+         in=1
+         write(unit,3000) text(1:1)
+      else
+         id=1
+         i1=1
+         i2=2
+         in=n
+      endif
+
+      if (n.lt.2) then
+         ndec=1
+         write(unit,1000) text,n,x(1)*a
+      else
+         dxmin=abs(x(2)-x(1))
+         do i=2,n-1
+            dx=abs(x(i+1)-x(i))
+            if (dx.lt.dxmin) dxmin=dx
+         enddo
+
+         ndec=-log10(dxmin)+2
+         if(mod(n,6).eq.1) then
+            write(unit,1000) text,n,x(i1)*a
+            write(unit,2000) (x(i)*a,i=i2,in,id)
+         else
+            write(unit,1000) text,n
+            write(unit,2000) (x(i)*a,i=i1,in,id)
+         endif
+      endif
+
+1000  format(a4,2x,i4,' LEVELS',43x,f12.2)
+2000  format(6f12.2)
+c1000  format(a4,2x,i4,' LEVELS',43x,f12.<ndec>)
+c2000  format(6f12.<ndec>)
+3000  format('FORMAT ',a1,'REV')
+      return
+
+      end
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/initfluxsto.F
===================================================================
--- LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/initfluxsto.F	(revision 253)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/initfluxsto.F	(revision 253)
@@ -0,0 +1,223 @@
+      subroutine initfluxsto
+     .  (infile,tstep,t_ops,t_wrt,nq,
+     .                    fileid,filevid,filedid)
+
+       USE IOIPSL
+
+      implicit none
+
+C
+C   Routine d'initialisation des ecritures des fichiers histoires LMDZ
+C   au format IOIPSL
+C
+C   Appels succesifs des routines: histbeg
+C                                  histhori
+C                                  histver
+C                                  histdef
+C                                  histend
+C
+C   Entree:
+C
+C      infile: nom du fichier histoire a creer
+C      day0,anne0: date de reference
+C      tstep: duree du pas de temps en seconde
+C      t_ops: frequence de l'operation pour IOIPSL
+C      t_wrt: frequence d'ecriture sur le fichier
+C      nq: nombre de traceurs
+C
+C   Sortie:
+C      fileid: ID du fichier netcdf cree
+C      filevid:ID du fichier netcdf pour la grille v
+C
+C   L. Fairhead, LMD, 03/99
+C
+C =====================================================================
+C
+C   Declarations
+#include "dimensions.h"
+#include "paramet.h"
+#include "comconst.h"
+#include "comvert.h"
+#include "comgeom.h"
+#include "temps.h"
+#include "ener.h"
+#include "logic.h"
+#include "description.h"
+#include "serre.h"
+
+C   Arguments
+C
+      character*(*) infile
+      integer*4 itau
+      real tstep, t_ops, t_wrt
+      integer fileid, filevid,filedid
+      integer nq,ndex(1)
+      real nivd(1)
+
+C   Variables locales
+C
+      integer tau0
+      real zjulian
+      character*3 str
+      character*10 ctrac
+      integer iq
+      real rlong(iip1,jjp1), rlat(iip1,jjp1),rl(1,1)
+      integer uhoriid, vhoriid, thoriid, zvertiid,dhoriid,dvertiid
+      integer ii,jj
+      integer zan
+      logical ok_sync
+C
+C  Initialisations
+C
+      pi = 4. * atan (1.)
+      str='q  '
+      ctrac = 'traceur   '
+      ok_sync = .true.
+C
+C  Appel a histbeg: creation du fichier netcdf et initialisations diverses
+C         
+
+      zan = anne_ini
+      CALL ymds2ju(zan, 1, 1, 0.0, zjulian)
+      zjulian = zjulian + day_ini
+      tau0 = 0
+	
+	do jj = 1, jjp1
+        do ii = 1, iip1
+          rlong(ii,jj) = rlonu(ii) * 180. / pi
+          rlat(ii,jj) = rlatu(jj) * 180. / pi
+        enddo
+      enddo
+ 
+      call histbeg(infile, iip1, rlong, jjp1, rlat,
+     .             1, iip1, 1, jjp1,
+     .             tau0, zjulian, tstep, uhoriid, fileid)
+C
+C  Creation du fichier histoire pour la grille en V (oblige pour l'instant,
+C  IOIPSL ne permet pas de grilles avec des nombres de point differents dans 
+C  un meme fichier)
+
+
+      do jj = 1, jjm
+        do ii = 1, iip1
+          rlong(ii,jj) = rlonv(ii) * 180. / pi
+          rlat(ii,jj) = rlatv(jj) * 180. / pi
+        enddo
+      enddo
+
+      call histbeg('fluxstokev.nc', iip1, rlong, jjm, rlat,
+     .             1, iip1, 1, jjm,
+     .             tau0, zjulian, tstep, vhoriid, filevid)
+	
+	rl(1,1) = 1.	
+      call histbeg('defstoke.nc', 1, rl, 1, rl,
+     .             1, 1, 1, 1,
+     .             tau0, zjulian, tstep, dhoriid, filedid)
+
+C
+C  Appel a histhori pour rajouter les autres grilles horizontales
+C
+      do jj = 1, jjp1
+        do ii = 1, iip1
+          rlong(ii,jj) = rlonv(ii) * 180. / pi
+          rlat(ii,jj) = rlatu(jj) * 180. / pi
+        enddo
+      enddo
+
+      call histhori(fileid, iip1, rlong, jjp1, rlat, 'scalar',
+     .              'Grille points scalaires', thoriid)
+	
+C
+C  Appel a histvert pour la grille verticale
+C
+      call histvert(fileid, 'sig_s', 'Niveaux sigma',
+     . 'sigma_level',
+     .              llm, nivsigs, zvertiid)
+C Pour le fichier V
+      call histvert(filevid, 'sig_s', 'Niveaux sigma',
+     .  'sigma_level',
+     .              llm, nivsigs, zvertiid)
+c pour le fichier def
+      nivd(1) = 1
+      call histvert(filedid, 'sig_s', 'Niveaux sigma',
+     .  'sigma_level',
+     .              1, nivd, dvertiid)
+
+C
+C  Appels a histdef pour la definition des variables a sauvegarder
+	
+	CALL histdef(fileid, "phis", "Surface geop. height", "-",
+     .                iip1,jjp1,thoriid, 1,1,1, -99, 32,
+     .                "once", t_ops, t_wrt)
+
+         CALL histdef(fileid, "aire", "Grid area", "-",
+     .                iip1,jjp1,thoriid, 1,1,1, -99, 32,
+     .                "once", t_ops, t_wrt)
+	
+	CALL histdef(filedid, "dtvr", "tps dyn", "s",
+     .                1,1,dhoriid, 1,1,1, -99, 32,
+     .                "once", t_ops, t_wrt)
+        
+         CALL histdef(filedid, "istdyn", "tps stock", "s",
+     .                1,1,dhoriid, 1,1,1, -99, 32,
+     .                "once", t_ops, t_wrt)
+         
+         CALL histdef(filedid, "istphy", "tps stock phy", "s",
+     .                1,1,dhoriid, 1,1,1, -99, 32,
+     .                "once", t_ops, t_wrt)
+
+
+C
+C Masse 
+C
+      call histdef(fileid, 'masse', 'Masse', 'kg',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+C
+C  Pbaru 
+C
+      call histdef(fileid, 'pbaru', 'flx de masse zonal', 'kg m/s',
+     .             iip1, jjp1, uhoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+
+C
+C  Pbarv 
+C
+      call histdef(filevid, 'pbarv', 'flx de masse mer', 'kg m/s',
+     .             iip1, jjm, vhoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+C
+C  w 
+C
+      call histdef(fileid, 'w', 'flx de masse vert', 'kg m/s',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+
+C
+C  Temperature potentielle
+C
+      call histdef(fileid, 'teta', 'temperature potentielle', '-',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+C
+
+C
+C Geopotentiel 
+C
+      call histdef(fileid, 'phi', 'geopotentiel instantane', '-',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'inst(X)', t_ops, t_wrt)
+C
+C  Fin
+C
+      call histend(fileid)
+      call histend(filevid)
+      call histend(filedid)
+      if (ok_sync) then
+        call histsync(fileid)
+        call histsync(filevid)
+        call histsync(filedid)
+      endif
+	
+      return
+      end
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/writedynav.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/bibio/writedynav.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/writedynav.F	(revision 253)
@@ -58,5 +58,5 @@
 C   Variables locales
 C
-      integer ndex(1),iq, ii, ll
+      integer ndex2d(iip1*jjp1),ndex3d(iip1*jjp1*llm),iq, ii, ll
       character*3 str
       real us(ip1jmp1*llm), vs(ip1jmp1*llm)
@@ -68,5 +68,6 @@
 C
       str='q  '
-      ndex(1) = 0
+      ndex3d = 0
+      ndex2d = 0
       ok_sync = .TRUE.
 
@@ -81,5 +82,5 @@
       call gr_u_scal(llm, unat, us)
       call histwrite(histid, 'u', time, us, 
-     .               iip1*jjp1*llm, ndex)
+     .               iip1*jjp1*llm, ndex3d)
 C
 C  Vents V scalaire
@@ -87,5 +88,5 @@
       call gr_v_scal(llm, vnat, vs)
       call histwrite(histid, 'v', time, vs, 
-     .               iip1*jjp1*llm, ndex)
+     .               iip1*jjp1*llm, ndex3d)
 C
 C  Temperature moyennee
@@ -95,10 +96,10 @@
       enddo
       call histwrite(histid, 'temp', time, tm, 
-     .                iip1*jjp1*llm, ndex)
+     .                iip1*jjp1*llm, ndex3d)
 C
 C  Geopotentiel
 C
       call histwrite(histid, 'phi', time, phi, 
-     .                iip1*jjp1*llm, ndex)
+     .                iip1*jjp1*llm, ndex3d)
 C
 C  Traceurs
@@ -112,5 +113,5 @@
           ENDIF
           call histwrite(histid, str, time, q(:,:,iq), 
-     .                   iip1*jjp1*llm, ndex)
+     .                   iip1*jjp1*llm, ndex3d)
         enddo
       endif
@@ -118,17 +119,17 @@
 C  Masse
 C
-       call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex)
+       call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex2d)
 C
 C  Pression au sol
 C
-       call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex)
+       call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-       call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex)
+       call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
 C
-      if (ok_sync) call histsync
+      if (ok_sync) call histsync(histid)
       return
       end
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/writehist.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/bibio/writehist.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/bibio/writehist.F	(revision 253)
@@ -59,5 +59,6 @@
 C   Variables locales
 C
-      integer ndex(1),iq, ii, ll
+      integer iq, ii, ll
+      integer ndexu(ip1jmp1*llm),ndexv(ip1jm*llm),ndex2d(ip1jmp1)
       character*3 str
       logical ok_sync
@@ -66,5 +67,7 @@
 C
       str='q  '
-      ndex(1) = 0
+      ndexu = 0
+      ndexv = 0
+      ndex2d = 0
       ok_sync =.TRUE.
 C
@@ -74,5 +77,5 @@
 C
       call histwrite(histid, 'ucov', time, ucov, 
-     .               iip1*jjp1*llm, ndex)
+     .               iip1*jjp1*llm, ndexu)
 
 C
@@ -80,5 +83,5 @@
 C
       call histwrite(histvid, 'vcov', time, vcov, 
-     .               iip1*jjm*llm, ndex)
+     .               iip1*jjm*llm, ndexv)
 
 C
@@ -86,10 +89,10 @@
 C
       call histwrite(histid, 'teta', time, teta, 
-     .                iip1*jjp1*llm, ndex)
+     .                iip1*jjp1*llm, ndexu)
 C
 C  Geopotentiel
 C
       call histwrite(histid, 'phi', time, phi, 
-     .                iip1*jjp1*llm, ndex)
+     .                iip1*jjp1*llm, ndexu)
 C
 C  Traceurs
@@ -103,5 +106,5 @@
           ENDIF
           call histwrite(histid, str, time, q(:,:,iq), 
-     .                   iip1*jjp1*llm, ndex)
+     .                   iip1*jjp1*llm, ndexu)
         enddo
       endif
@@ -109,17 +112,20 @@
 C  Masse
 C
-      call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex)
+      call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex2d)
 C
 C  Pression au sol
 C
-      call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex)
+      call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-      call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex)
+      call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
 C
-      if (ok_sync) call histsync
+      if (ok_sync) then
+        call histsync(histid)
+        call histsync(histvid)
+      endif
       return
       end
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/addfi.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/dyn3d/addfi.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/addfi.F	(revision 253)
@@ -67,6 +67,7 @@
       REAL xpn(iim),xps(iim),tpn,tps
       INTEGER j,k,iq,ij
-      REAL qtest
-      PARAMETER ( qtest = 1.0e-30 )
+      REAL qtestw, qtestt
+      PARAMETER ( qtestw = 1.0e-15 )
+      PARAMETER ( qtestt = 1.0e-40 )
 
       REAL SSUM
@@ -81,19 +82,17 @@
       ENDDO
 
-      IF( alphax.NE.0. )   THEN
-        DO  k    = 1, llm
-         DO  ij   = 1, iim
-          xpn(ij) = aire(   ij   ) * pteta(  ij    ,k)
-          xps(ij) = aire(ij+ip1jm) * pteta(ij+ip1jm,k)
-         ENDDO
-          tpn      = SSUM(iim,xpn,1)/ apoln
-          tps      = SSUM(iim,xps,1)/ apols
+      DO  k    = 1, llm
+       DO  ij   = 1, iim
+         xpn(ij) = aire(   ij   ) * pteta(  ij    ,k)
+         xps(ij) = aire(ij+ip1jm) * pteta(ij+ip1jm,k)
+       ENDDO
+       tpn      = SSUM(iim,xpn,1)/ apoln
+       tps      = SSUM(iim,xps,1)/ apols
 
-         DO ij   = 1, iip1
-          pteta(   ij   ,k)  = tpn
-          pteta(ij+ip1jm,k)  = tps
-         ENDDO
-        ENDDO
-      ENDIF
+       DO ij   = 1, iip1
+         pteta(   ij   ,k)  = tpn
+         pteta(ij+ip1jm,k)  = tps
+       ENDDO
+      ENDDO
 c
 
@@ -114,13 +113,19 @@
          pps(j) = pps(j) + pdpfi(j) * pdt
       ENDDO
-
-c
-
-      DO iq = 1, nq
+ 
+      DO iq = 1, 2
          DO k = 1,llm
             DO j = 1,ip1jmp1
                pq(j,k,iq)= pq(j,k,iq) + pdqfi(j,k,iq) * pdt
-               pq(j,k,iq)= AMAX1( pq(j,k,iq), qtest )
-ccc              pq(j,k,iq)=qtest
+               pq(j,k,iq)= AMAX1( pq(j,k,iq), qtestw )
+            ENDDO
+         ENDDO
+      ENDDO
+
+      DO iq = 3, nq
+         DO k = 1,llm
+            DO j = 1,ip1jmp1
+               pq(j,k,iq)= pq(j,k,iq) + pdqfi(j,k,iq) * pdt
+               pq(j,k,iq)= AMAX1( pq(j,k,iq), qtestt )
             ENDDO
          ENDDO
@@ -128,37 +133,32 @@
 
 
-      IF( alphax.NE.0. )   THEN
+      DO  ij   = 1, iim
+        xpn(ij) = aire(   ij   ) * pps(  ij     )
+        xps(ij) = aire(ij+ip1jm) * pps(ij+ip1jm )
+      ENDDO
+      tpn      = SSUM(iim,xpn,1)/apoln
+      tps      = SSUM(iim,xps,1)/apols
 
-         DO  ij   = 1, iim
-          xpn(ij) = aire(   ij   ) * pps(  ij     )
-          xps(ij) = aire(ij+ip1jm) * pps(ij+ip1jm )
-         ENDDO
+      DO ij   = 1, iip1
+        pps (   ij     )  = tpn
+        pps ( ij+ip1jm )  = tps
+      ENDDO
+
+
+      DO iq = 1, nq
+        DO  k    = 1, llm
+          DO  ij   = 1, iim
+            xpn(ij) = aire(   ij   ) * pq(  ij    ,k,iq)
+            xps(ij) = aire(ij+ip1jm) * pq(ij+ip1jm,k,iq)
+          ENDDO
           tpn      = SSUM(iim,xpn,1)/apoln
           tps      = SSUM(iim,xps,1)/apols
 
-         DO ij   = 1, iip1
-          pps (   ij     )  = tpn
-          pps ( ij+ip1jm )  = tps
-         ENDDO
-
-
-       DO iq = 1, nq
-         DO  k    = 1, llm
-           DO  ij   = 1, iim
-            xpn(ij) = aire(   ij   ) * pq(  ij    ,k,iq)
-            xps(ij) = aire(ij+ip1jm) * pq(ij+ip1jm,k,iq)
-           ENDDO
-            tpn      = SSUM(iim,xpn,1)/apoln
-            tps      = SSUM(iim,xps,1)/apols
-
-           DO ij   = 1, iip1
+          DO ij   = 1, iip1
             pq (   ij   ,k,iq)  = tpn
             pq (ij+ip1jm,k,iq)  = tps
-           ENDDO
-         ENDDO
-       ENDDO
-
-      ENDIF
-
+          ENDDO
+        ENDDO
+      ENDDO
 
       RETURN
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/calfis.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/dyn3d/calfis.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/calfis.F	(revision 253)
@@ -141,4 +141,5 @@
       REAL latfi(ngridmx),lonfi(ngridmx)
       REAL airefi(ngridmx)
+      SAVE latfi, lonfi, airefi
 
       LOGICAL firstcal, debut
@@ -311,13 +312,13 @@
 c
       DO l=1,llm
-        pvervel(1,l)=pw(1,1,l)/apoln
+        pvervel(1,l)=pw(1,1,l) * g /apoln
         ig0=2
        DO j=2,jjm
            DO i = 1, iim
-              pvervel(ig0,l) = pw(i,j,l) * unsaire(i,j)
+              pvervel(ig0,l) = pw(i,j,l) * g * unsaire(i,j)
               ig0 = ig0 + 1
            ENDDO
        ENDDO
-        pvervel(ig0,l)=pw(1,jjp1,l)/apols
+        pvervel(ig0,l)=pw(1,jjp1,l) * g /apols
       ENDDO
 
@@ -428,5 +429,6 @@
      ,   rdayvrai,rday_ecri,heure,dtphys,zplev,zplay,zphi,zphis,airefi,
      ,             presnivs,clesphy0,  zufi, zvfi,ztfi, zqfi,  
-     ,             pcvgu, pcvgv, pcvgt, pcvgq, pvervel,
+ccc     ,             pcvgu, pcvgv, pcvgt, pcvgq, 
+     ,             pvervel,
 C - sorties
      s             zdufi, zdvfi, zdtfi, zdqfi,zdpsrf              )
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/coefpoly.F
===================================================================
--- LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/coefpoly.F	(revision 253)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/coefpoly.F	(revision 253)
@@ -0,0 +1,38 @@
+c $Header$
+      SUBROUTINE coefpoly ( Xf1, Xf2, Xprim1, Xprim2, xtild1,xtild2 ,
+     ,                                          a0,a1,a2,a3         )
+      IMPLICIT NONE
+c
+c   ...  Auteur :   P. Le Van  ...
+c
+c
+c    Calcul des coefficients a0, a1, a2, a3 du polynome de degre 3 qui
+c      satisfait aux 4 equations  suivantes :
+
+c    a0 + a1*xtild1 + a2*xtild1*xtild1 + a3*xtild1*xtild1*xtild1 = Xf1
+c    a0 + a1*xtild2 + a2*xtild2*xtild2 + a3*xtild2*xtild2*xtild2 = Xf2
+c               a1  +     2.*a2*xtild1 +     3.*a3*xtild1*xtild1 = Xprim1
+c               a1  +     2.*a2*xtild2 +     3.*a3*xtild2*xtild2 = Xprim2
+
+c  On en revient a resoudre un systeme de 4 equat.a 4 inconnues a0,a1,a2,a3
+
+      REAL*8 Xf1, Xf2,Xprim1,Xprim2, xtild1,xtild2, xi 
+      REAL*8 Xfout, Xprim
+      REAL*8 a1,a2,a3,a0, xtil1car, xtil2car,derr,x1x2car
+
+      xtil1car = xtild1 * xtild1
+      xtil2car = xtild2 * xtild2 
+
+      derr= 2. *(Xf2-Xf1)/( xtild1-xtild2)
+
+      x1x2car = ( xtild1-xtild2)*(xtild1-xtild2)
+
+      a3 = (derr + Xprim1+Xprim2 )/x1x2car
+      a2     = ( Xprim1 - Xprim2 + 3.* a3 * ( xtil2car-xtil1car ) )    /
+     /           (  2.* ( xtild1 - xtild2 )  )
+
+      a1     = Xprim1 -3.* a3 * xtil1car     -2.* a2 * xtild1
+      a0     =  Xf1 - a3 * xtild1* xtil1car -a2 * xtil1car - a1 *xtild1
+
+      RETURN
+      END
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/comvert.h
===================================================================
--- LMDZ.3.3/branches/LF/libf/dyn3d/comvert.h	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/comvert.h	(revision 253)
@@ -3,5 +3,5 @@
 
       COMMON/comvert/ap(llm+1),bp(llm+1),presnivs(llm),dpres(llm) ,
-     ,               pa,preff,nivsigs(llm),nivsig(llmp1)
+     ,               pa,preff,nivsigs(llm),nivsig(llm+1)
 
       REAL ap,bp,presnivs,dpres,pa,preff,nivsigs,nivsig
Index: LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/create_limit.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/dyn3d/create_limit.F	(revision 3)
+++ LMDZ.3.3/branches/rel-1-0-patch/libf/dyn3d/create_limit.F	(revision 253)
@@ -137,5 +137,11 @@
         STOP
       ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlon_msk)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlon_msk)
+#endif
+
+c
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -153,10 +159,20 @@
         STOP
       ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlat_msk)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlat_msk)
-      if (ierr.ne.0) then
-        print *, NF_STRERROR(ierr)
-        STOP
-      ENDIF
+#endif
+c
+      if (ierr.ne.0) then
+        print *, NF_STRERROR(ierr)
+        STOP
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,varid,champ_msk)
+#else
       ierr = NF_GET_VAR_REAL(ncid,varid,champ_msk)
+#endif
+c
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -211,5 +227,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlon)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlon)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -227,5 +247,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlat)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlat)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -243,5 +267,9 @@
         STOP
       ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,timecoord)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,timecoord)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -260,5 +288,9 @@
          PRINT*,'Lecture temporelle et int. horizontale ',l,timecoord(l)
          print*,dimfirst,dimlast
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VARA_DOUBLE(ncid,varid,dimfirst,dimlast,champ)
+#else
          ierr = NF_GET_VARA_REAL(ncid,varid,dimfirst,dimlast,champ)
+#endif
          if (ierr.ne.0) then
            print *, NF_STRERROR(ierr)
@@ -343,5 +375,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlon)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlon)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -359,5 +395,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlat)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlat)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -375,5 +415,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,timecoord)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,timecoord)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -391,5 +435,9 @@
 c
          PRINT*,'Lecture temporelle et int. horizontale ',l,timecoord(l)
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VARA_DOUBLE(ncid,varid,dimfirst,dimlast,champ)
+#else
          ierr = NF_GET_VARA_REAL(ncid,varid,dimfirst,dimlast,champ)
+#endif
          if (ierr.ne.0) then
            print *, NF_STRERROR(ierr)
@@ -480,5 +528,10 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlon)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlon)
+#endif
+
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -496,5 +549,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlat)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlat)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -512,5 +569,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,timecoord)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,timecoord)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -528,5 +589,9 @@
 c
          PRINT*,'Lecture temporelle et int. horizontale ',l,timecoord(l)
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VARA_DOUBLE(ncid,varid,dimfirst,dimlast,champ)
+#else
          ierr = NF_GET_VARA_REAL(ncid,varid,dimfirst,dimlast,champ)
+#endif
          if (ierr.ne.0) then
            print *, NF_STRERROR(ierr)
@@ -606,5 +671,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlon)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlon)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -622,5 +691,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,dlat)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,dlat)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -638,5 +711,9 @@
         STOP
       ENDIF 
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(ncid,dimid,timecoord)
+#else
       ierr = NF_GET_VAR_REAL(ncid,dimid,timecoord)
+#endif
       if (ierr.ne.0) then
         print *, NF_STRERROR(ierr)
@@ -654,5 +731,9 @@
 c
          PRINT*,'Lecture temporelle et int. horizontale ',l,timecoord(l)
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VARA_DOUBLE(ncid,varid,dimfirst,dimlast,champ)
+#else
          ierr = NF_GET_VARA_REAL(ncid,varid,dimfirst,dimlast,champ)
+#endif
          if (ierr.ne.0) then
            print *, NF_STRERROR(ierr)
